on run argv
  set the presentationToExtract to item 1 of argv
  set the targetDirectory to item 2 of argv

  set the defaultDestinationFolder to POSIX file ("/tmp/" & targetDirectory & "/")

  tell application "Keynote"
    open presentationToExtract

    try
      if playing is true then tell the front document to stop

      if not (exists document 1) then error number -128

      tell front document
        set documentName to its name
        if documentName ends with ".key" then ¬
				set documentName to text 1 thru -5 of documentName
      end tell

      tell application "Finder"
        set newExportItemName to item 2 of argv & ".key"
        set incrementIndex to 1
        repeat until not (exists document file newExportItemName of defaultDestinationFolder)
          set newExportItemName to ¬
					documentName & "-" & (incrementIndex as string) & ".key"
          set incrementIndex to incrementIndex + 1
        end repeat
      end tell
      set the targetFileHFSPath to (defaultDestinationFolder as string) & newExportItemName

      -- EXPORT THE DOCUMENT
      with timeout of 1200 seconds
        export front document to file targetFileHFSPath as Keynote 09
      end timeout

      set exportedItemPath to targetFileHFSPath

    on error errorMessage number errorNumber
      display alert "EXPORT PROBLEM" message errorMessage
      error number -128
    end try
  end tell
end run
