const cheerio = require('cheerio');
const fs = require('fs');
const path = require('path');
const glob = require('glob');
const marked = require('marked');
const exec = require('child_process').execSync;

module.exports = {
  transform: function () {
    const directory = `/tmp/keynote-extractor`;
    const outputPath = path.join(directory, 'output');
    const outputImagesPath = path.join(directory, 'output/images');
    const images = glob.sync(path.join(directory, '*.png'));
    const htmlContents = fs.readFileSync(path.join(directory, 'extracted.html'), 'utf8');
    const $ = cheerio.load(htmlContents);

    $('head').append('<link rel="stylesheet" href="slides.css">');

    $('article')
      .each(function (index, article) {
        const notesHtml = $(this).html();
        $(this).addClass('slide').html(`
            <img class="slide-image" src="images/${path.parse(images[index]).base}">
            <div class="slide-annotations">${marked(notesHtml)}</div>
        `);
      });

    exec(`mkdir ${outputPath}`);

    fs.writeFileSync(path.join(outputPath, 'index.html'), $.html());

    exec(`mkdir ${outputImagesPath}`);

    exec(`mv ${directory}/*.png ${outputImagesPath}`);

    exec(`cp ${path.join(__dirname, '../slides.css')} ${outputPath}`);
  }
};
