const extractor = require('../src/extractor');
const should = require('should');
const fs = require('fs');
const path = require('path');
const rimraf = require('rimraf');
const async = require('async');

const PATH_TO_TEST_FILE = path.join(process.cwd(), 'test/test-data/presentation.key');
const AMOUNT_OF_SLIDES_IN_FILE = 3;
const PATH_TO_TMP_EXTRACTOR_DIRECTORY = '/tmp/keynote-extractor';

describe('Extractor', function () {
  beforeEach(function (done) {
    this.timeout(10000);
    rimraf(PATH_TO_TMP_EXTRACTOR_DIRECTORY, function () {
      extractor.extract(PATH_TO_TEST_FILE).then(function () {
        done();
      });
    });
  });

  it('should generate an HTML file', function (done) {
    fs.stat(path.join(PATH_TO_TMP_EXTRACTOR_DIRECTORY, 'extracted.html'), function (err, stats) {
      should(stats).be.ok();
      done();
    });
  });

  it('should generate the appropriate amount of images', function (done) {
    const imagePaths = [];

    for (var i = 0; i < AMOUNT_OF_SLIDES_IN_FILE; i++) {
      imagePaths.push(path.join(PATH_TO_TMP_EXTRACTOR_DIRECTORY, `keynote-extractor.00${AMOUNT_OF_SLIDES_IN_FILE}.png`))
    }

    async.map(imagePaths, fs.stat, function (err, results) {
      results.length.should.equal(AMOUNT_OF_SLIDES_IN_FILE);
      done();
    });
  });
});
